# coding: utf-8

"""
EVR API

OpenAPI Generator'i jaoks kohandatud EVR API kirjeldus. Kasuta seda juhul, kui spetsifikatsioonile vastava EVR API kirjeldusega ei õnnestu klienti genereerida.

The version of the OpenAPI document: 1.30.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

import warnings
from typing import Any, Dict, List, Optional, Tuple, Union

from pydantic import Field, StrictFloat, StrictInt, StrictStr, validate_call
from typing_extensions import Annotated

from pyevr.openapi_client.api_client import ApiClient, RequestSerialized
from pyevr.openapi_client.api_response import ApiResponse
from pyevr.openapi_client.models.paged_result_of_place_of_delivery import (
    PagedResultOfPlaceOfDelivery,
)
from pyevr.openapi_client.models.place_of_delivery import PlaceOfDelivery
from pyevr.openapi_client.models.put_place_of_delivery_request import (
    PutPlaceOfDeliveryRequest,
)
from pyevr.openapi_client.rest import RESTResponseType


class PlaceOfDeliveriesApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @validate_call
    def place_of_deliveries_add_or_update(
        self,
        code: Annotated[StrictStr, Field(description="Kood")],
        put_place_of_delivery_request: PutPlaceOfDeliveryRequest,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> None:
        """Tarnekoha lisamine ja muutmine

        Lisab uue tarnekoha. Kui antud koodiga tarnekoht juba eksisteerib, siis muudab olemasolevat tarnekohta. Loomisel märgitakse päringu tegija tarnekoha omanikuks.

        :param code: Kood (required)
        :type code: str
        :param put_place_of_delivery_request: (required)
        :type put_place_of_delivery_request: PutPlaceOfDeliveryRequest
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._place_of_deliveries_add_or_update_serialize(
            code=code,
            put_place_of_delivery_request=put_place_of_delivery_request,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "200": None,
            "400": "ValidationResult",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data

    @validate_call
    def place_of_deliveries_add_or_update_with_http_info(
        self,
        code: Annotated[StrictStr, Field(description="Kood")],
        put_place_of_delivery_request: PutPlaceOfDeliveryRequest,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[None]:
        """Tarnekoha lisamine ja muutmine

        Lisab uue tarnekoha. Kui antud koodiga tarnekoht juba eksisteerib, siis muudab olemasolevat tarnekohta. Loomisel märgitakse päringu tegija tarnekoha omanikuks.

        :param code: Kood (required)
        :type code: str
        :param put_place_of_delivery_request: (required)
        :type put_place_of_delivery_request: PutPlaceOfDeliveryRequest
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._place_of_deliveries_add_or_update_serialize(
            code=code,
            put_place_of_delivery_request=put_place_of_delivery_request,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "200": None,
            "400": "ValidationResult",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )

    @validate_call
    def place_of_deliveries_add_or_update_without_preload_content(
        self,
        code: Annotated[StrictStr, Field(description="Kood")],
        put_place_of_delivery_request: PutPlaceOfDeliveryRequest,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Tarnekoha lisamine ja muutmine

        Lisab uue tarnekoha. Kui antud koodiga tarnekoht juba eksisteerib, siis muudab olemasolevat tarnekohta. Loomisel märgitakse päringu tegija tarnekoha omanikuks.

        :param code: Kood (required)
        :type code: str
        :param put_place_of_delivery_request: (required)
        :type put_place_of_delivery_request: PutPlaceOfDeliveryRequest
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._place_of_deliveries_add_or_update_serialize(
            code=code,
            put_place_of_delivery_request=put_place_of_delivery_request,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "200": None,
            "400": "ValidationResult",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        return response_data.response

    def _place_of_deliveries_add_or_update_serialize(
        self,
        code,
        put_place_of_delivery_request,
        evr_language,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:
        _host = None

        _collection_formats: Dict[str, str] = {}

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if code is not None:
            _path_params["code"] = code
        # process the query parameters
        # process the header parameters
        if evr_language is not None:
            _header_params["EVR-LANGUAGE"] = evr_language
        # process the form parameters
        # process the body parameter
        if put_place_of_delivery_request is not None:
            _body_params = put_place_of_delivery_request

        # set the HTTP header `Accept`
        if "Accept" not in _header_params:
            _header_params["Accept"] = self.api_client.select_header_accept(
                ["application/json"]
            )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params["Content-Type"] = _content_type
        else:
            _default_content_type = self.api_client.select_header_content_type(
                ["application/json"]
            )
            if _default_content_type is not None:
                _header_params["Content-Type"] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = ["SecretApiKey"]

        return self.api_client.param_serialize(
            method="PUT",
            resource_path="/api/placeofdeliveries/{code}",
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth,
        )

    @validate_call
    def place_of_deliveries_get(
        self,
        code: Annotated[
            StrictStr, Field(description="Päritava tarnekoha kood (tõstutundlik)")
        ],
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> PlaceOfDelivery:
        """Tarnekoha pärimine

        Tagastab koodile vastava tarnekoha. Pärida saab ainult enda asutusele kuuluvat tarnekohta.

        :param code: Päritava tarnekoha kood (tõstutundlik) (required)
        :type code: str
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._place_of_deliveries_get_serialize(
            code=code,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "404": "ProblemDetails",
            "200": "PlaceOfDelivery",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data

    @validate_call
    def place_of_deliveries_get_with_http_info(
        self,
        code: Annotated[
            StrictStr, Field(description="Päritava tarnekoha kood (tõstutundlik)")
        ],
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[PlaceOfDelivery]:
        """Tarnekoha pärimine

        Tagastab koodile vastava tarnekoha. Pärida saab ainult enda asutusele kuuluvat tarnekohta.

        :param code: Päritava tarnekoha kood (tõstutundlik) (required)
        :type code: str
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._place_of_deliveries_get_serialize(
            code=code,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "404": "ProblemDetails",
            "200": "PlaceOfDelivery",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )

    @validate_call
    def place_of_deliveries_get_without_preload_content(
        self,
        code: Annotated[
            StrictStr, Field(description="Päritava tarnekoha kood (tõstutundlik)")
        ],
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Tarnekoha pärimine

        Tagastab koodile vastava tarnekoha. Pärida saab ainult enda asutusele kuuluvat tarnekohta.

        :param code: Päritava tarnekoha kood (tõstutundlik) (required)
        :type code: str
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._place_of_deliveries_get_serialize(
            code=code,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "404": "ProblemDetails",
            "200": "PlaceOfDelivery",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        return response_data.response

    def _place_of_deliveries_get_serialize(
        self,
        code,
        evr_language,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:
        _host = None

        _collection_formats: Dict[str, str] = {}

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if code is not None:
            _path_params["code"] = code
        # process the query parameters
        # process the header parameters
        if evr_language is not None:
            _header_params["EVR-LANGUAGE"] = evr_language
        # process the form parameters
        # process the body parameter

        # set the HTTP header `Accept`
        if "Accept" not in _header_params:
            _header_params["Accept"] = self.api_client.select_header_accept(
                ["application/json"]
            )

        # authentication setting
        _auth_settings: List[str] = ["SecretApiKey"]

        return self.api_client.param_serialize(
            method="GET",
            resource_path="/api/placeofdeliveries/{code}",
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth,
        )

    @validate_call
    def place_of_deliveries_list(
        self,
        name_contains: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib tarnekohad, mille nimi sisaldab otsinguterminit"
            ),
        ] = None,
        code_starts_with: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib tarnekohad, mille kood algab otsinguterminiga (tõstutundlik)"
            ),
        ] = None,
        register_code: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib ettevõtte tarnekohad, mille registrikood vastab otsinguterminile"
            ),
        ] = None,
        address: Annotated[
            Optional[StrictStr],
            Field(
                description="Vabatekstiline aadressi otsing. Toetatud on järgmine süntaks: * ilma jutumärkideta tekst: sõnade vahel rakendatakse loogiline JA * jutumärkides tekst: otsitakse jutumärkides olevat lauset * OR: loogiline VÕI operaator sõnade vahel * -: loogiline EITUS"
            ),
        ] = None,
        page: Annotated[
            Optional[Annotated[int, Field(le=2147483647, strict=True, ge=1)]],
            Field(description="Tagastatav lehekülg"),
        ] = None,
        page_size: Annotated[
            Optional[Annotated[int, Field(le=500, strict=True, ge=1)]],
            Field(description="Tagastatava lehekülje suurus"),
        ] = None,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> PagedResultOfPlaceOfDelivery:
        """Tarnekohtade pärimine

        Tagastab filtritele vastavad aktiivsed  tarnekohad ja kõik ettevõttega seotud tarnekohad.

        :param name_contains: Filtreerib tarnekohad, mille nimi sisaldab otsinguterminit
        :type name_contains: str
        :param code_starts_with: Filtreerib tarnekohad, mille kood algab otsinguterminiga (tõstutundlik)
        :type code_starts_with: str
        :param register_code: Filtreerib ettevõtte tarnekohad, mille registrikood vastab otsinguterminile
        :type register_code: str
        :param address: Vabatekstiline aadressi otsing. Toetatud on järgmine süntaks: * ilma jutumärkideta tekst: sõnade vahel rakendatakse loogiline JA * jutumärkides tekst: otsitakse jutumärkides olevat lauset * OR: loogiline VÕI operaator sõnade vahel * -: loogiline EITUS
        :type address: str
        :param page: Tagastatav lehekülg
        :type page: int
        :param page_size: Tagastatava lehekülje suurus
        :type page_size: int
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._place_of_deliveries_list_serialize(
            name_contains=name_contains,
            code_starts_with=code_starts_with,
            register_code=register_code,
            address=address,
            page=page,
            page_size=page_size,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "400": "ValidationResult",
            "200": "PagedResultOfPlaceOfDelivery",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data

    @validate_call
    def place_of_deliveries_list_with_http_info(
        self,
        name_contains: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib tarnekohad, mille nimi sisaldab otsinguterminit"
            ),
        ] = None,
        code_starts_with: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib tarnekohad, mille kood algab otsinguterminiga (tõstutundlik)"
            ),
        ] = None,
        register_code: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib ettevõtte tarnekohad, mille registrikood vastab otsinguterminile"
            ),
        ] = None,
        address: Annotated[
            Optional[StrictStr],
            Field(
                description="Vabatekstiline aadressi otsing. Toetatud on järgmine süntaks: * ilma jutumärkideta tekst: sõnade vahel rakendatakse loogiline JA * jutumärkides tekst: otsitakse jutumärkides olevat lauset * OR: loogiline VÕI operaator sõnade vahel * -: loogiline EITUS"
            ),
        ] = None,
        page: Annotated[
            Optional[Annotated[int, Field(le=2147483647, strict=True, ge=1)]],
            Field(description="Tagastatav lehekülg"),
        ] = None,
        page_size: Annotated[
            Optional[Annotated[int, Field(le=500, strict=True, ge=1)]],
            Field(description="Tagastatava lehekülje suurus"),
        ] = None,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[PagedResultOfPlaceOfDelivery]:
        """Tarnekohtade pärimine

        Tagastab filtritele vastavad aktiivsed  tarnekohad ja kõik ettevõttega seotud tarnekohad.

        :param name_contains: Filtreerib tarnekohad, mille nimi sisaldab otsinguterminit
        :type name_contains: str
        :param code_starts_with: Filtreerib tarnekohad, mille kood algab otsinguterminiga (tõstutundlik)
        :type code_starts_with: str
        :param register_code: Filtreerib ettevõtte tarnekohad, mille registrikood vastab otsinguterminile
        :type register_code: str
        :param address: Vabatekstiline aadressi otsing. Toetatud on järgmine süntaks: * ilma jutumärkideta tekst: sõnade vahel rakendatakse loogiline JA * jutumärkides tekst: otsitakse jutumärkides olevat lauset * OR: loogiline VÕI operaator sõnade vahel * -: loogiline EITUS
        :type address: str
        :param page: Tagastatav lehekülg
        :type page: int
        :param page_size: Tagastatava lehekülje suurus
        :type page_size: int
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._place_of_deliveries_list_serialize(
            name_contains=name_contains,
            code_starts_with=code_starts_with,
            register_code=register_code,
            address=address,
            page=page,
            page_size=page_size,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "400": "ValidationResult",
            "200": "PagedResultOfPlaceOfDelivery",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )

    @validate_call
    def place_of_deliveries_list_without_preload_content(
        self,
        name_contains: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib tarnekohad, mille nimi sisaldab otsinguterminit"
            ),
        ] = None,
        code_starts_with: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib tarnekohad, mille kood algab otsinguterminiga (tõstutundlik)"
            ),
        ] = None,
        register_code: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib ettevõtte tarnekohad, mille registrikood vastab otsinguterminile"
            ),
        ] = None,
        address: Annotated[
            Optional[StrictStr],
            Field(
                description="Vabatekstiline aadressi otsing. Toetatud on järgmine süntaks: * ilma jutumärkideta tekst: sõnade vahel rakendatakse loogiline JA * jutumärkides tekst: otsitakse jutumärkides olevat lauset * OR: loogiline VÕI operaator sõnade vahel * -: loogiline EITUS"
            ),
        ] = None,
        page: Annotated[
            Optional[Annotated[int, Field(le=2147483647, strict=True, ge=1)]],
            Field(description="Tagastatav lehekülg"),
        ] = None,
        page_size: Annotated[
            Optional[Annotated[int, Field(le=500, strict=True, ge=1)]],
            Field(description="Tagastatava lehekülje suurus"),
        ] = None,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Tarnekohtade pärimine

        Tagastab filtritele vastavad aktiivsed  tarnekohad ja kõik ettevõttega seotud tarnekohad.

        :param name_contains: Filtreerib tarnekohad, mille nimi sisaldab otsinguterminit
        :type name_contains: str
        :param code_starts_with: Filtreerib tarnekohad, mille kood algab otsinguterminiga (tõstutundlik)
        :type code_starts_with: str
        :param register_code: Filtreerib ettevõtte tarnekohad, mille registrikood vastab otsinguterminile
        :type register_code: str
        :param address: Vabatekstiline aadressi otsing. Toetatud on järgmine süntaks: * ilma jutumärkideta tekst: sõnade vahel rakendatakse loogiline JA * jutumärkides tekst: otsitakse jutumärkides olevat lauset * OR: loogiline VÕI operaator sõnade vahel * -: loogiline EITUS
        :type address: str
        :param page: Tagastatav lehekülg
        :type page: int
        :param page_size: Tagastatava lehekülje suurus
        :type page_size: int
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._place_of_deliveries_list_serialize(
            name_contains=name_contains,
            code_starts_with=code_starts_with,
            register_code=register_code,
            address=address,
            page=page,
            page_size=page_size,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "400": "ValidationResult",
            "200": "PagedResultOfPlaceOfDelivery",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        return response_data.response

    def _place_of_deliveries_list_serialize(
        self,
        name_contains,
        code_starts_with,
        register_code,
        address,
        page,
        page_size,
        evr_language,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:
        _host = None

        _collection_formats: Dict[str, str] = {}

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        if name_contains is not None:
            _query_params.append(("name_contains", name_contains))

        if code_starts_with is not None:
            _query_params.append(("code_starts_with", code_starts_with))

        if register_code is not None:
            _query_params.append(("register_code", register_code))

        if address is not None:
            _query_params.append(("address", address))

        if page is not None:
            _query_params.append(("page", page))

        if page_size is not None:
            _query_params.append(("page_size", page_size))

        # process the header parameters
        if evr_language is not None:
            _header_params["EVR-LANGUAGE"] = evr_language
        # process the form parameters
        # process the body parameter

        # set the HTTP header `Accept`
        if "Accept" not in _header_params:
            _header_params["Accept"] = self.api_client.select_header_accept(
                ["application/json"]
            )

        # authentication setting
        _auth_settings: List[str] = ["SecretApiKey"]

        return self.api_client.param_serialize(
            method="GET",
            resource_path="/api/placeofdeliveries",
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth,
        )
