# coding: utf-8

"""
EVR API

OpenAPI Generator'i jaoks kohandatud EVR API kirjeldus. Kasuta seda juhul, kui spetsifikatsioonile vastava EVR API kirjeldusega ei õnnestu klienti genereerida.

The version of the OpenAPI document: 1.30.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

import warnings
from datetime import datetime
from typing import Any, Dict, List, Optional, Tuple, Union

from pydantic import Field, StrictBool, StrictFloat, StrictInt, StrictStr, validate_call
from typing_extensions import Annotated

from pyevr.openapi_client.api_client import ApiClient, RequestSerialized
from pyevr.openapi_client.api_response import ApiResponse
from pyevr.openapi_client.models.add_shipments_to_waybill_request import (
    AddShipmentsToWaybillRequest,
)
from pyevr.openapi_client.models.add_waybill_note_request import AddWaybillNoteRequest
from pyevr.openapi_client.models.cancel_waybill_request import CancelWaybillRequest
from pyevr.openapi_client.models.paged_result_of_waybill import PagedResultOfWaybill
from pyevr.openapi_client.models.start_waybill_request import StartWaybillRequest
from pyevr.openapi_client.models.unload_waybill_request import UnloadWaybillRequest
from pyevr.openapi_client.models.waybill import Waybill
from pyevr.openapi_client.models.waybill_sort_field import WaybillSortField
from pyevr.openapi_client.models.waybill_status import WaybillStatus
from pyevr.openapi_client.rest import RESTResponseType


class WaybillsApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @validate_call
    def waybills_add_note(
        self,
        number: Annotated[
            StrictStr, Field(description="Veoselehe number (tõstutundetu)")
        ],
        add_waybill_note_request: AddWaybillNoteRequest,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> None:
        """Veoselehe märkuse lisamine

        Lisab veoselehele uue märkuse. Olemasolevaid märkuseid ei muudeta. Märkust saavad lisada kõik veoselehega seotud osapooled (v.a volitatud vaatleja).

        :param number: Veoselehe number (tõstutundetu) (required)
        :type number: str
        :param add_waybill_note_request: (required)
        :type add_waybill_note_request: AddWaybillNoteRequest
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_add_note_serialize(
            number=number,
            add_waybill_note_request=add_waybill_note_request,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "404": "ProblemDetails",
            "400": "ValidationResult",
            "200": None,
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data

    @validate_call
    def waybills_add_note_with_http_info(
        self,
        number: Annotated[
            StrictStr, Field(description="Veoselehe number (tõstutundetu)")
        ],
        add_waybill_note_request: AddWaybillNoteRequest,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[None]:
        """Veoselehe märkuse lisamine

        Lisab veoselehele uue märkuse. Olemasolevaid märkuseid ei muudeta. Märkust saavad lisada kõik veoselehega seotud osapooled (v.a volitatud vaatleja).

        :param number: Veoselehe number (tõstutundetu) (required)
        :type number: str
        :param add_waybill_note_request: (required)
        :type add_waybill_note_request: AddWaybillNoteRequest
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_add_note_serialize(
            number=number,
            add_waybill_note_request=add_waybill_note_request,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "404": "ProblemDetails",
            "400": "ValidationResult",
            "200": None,
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )

    @validate_call
    def waybills_add_note_without_preload_content(
        self,
        number: Annotated[
            StrictStr, Field(description="Veoselehe number (tõstutundetu)")
        ],
        add_waybill_note_request: AddWaybillNoteRequest,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Veoselehe märkuse lisamine

        Lisab veoselehele uue märkuse. Olemasolevaid märkuseid ei muudeta. Märkust saavad lisada kõik veoselehega seotud osapooled (v.a volitatud vaatleja).

        :param number: Veoselehe number (tõstutundetu) (required)
        :type number: str
        :param add_waybill_note_request: (required)
        :type add_waybill_note_request: AddWaybillNoteRequest
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_add_note_serialize(
            number=number,
            add_waybill_note_request=add_waybill_note_request,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "404": "ProblemDetails",
            "400": "ValidationResult",
            "200": None,
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        return response_data.response

    def _waybills_add_note_serialize(
        self,
        number,
        add_waybill_note_request,
        evr_language,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:
        _host = None

        _collection_formats: Dict[str, str] = {}

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if number is not None:
            _path_params["number"] = number
        # process the query parameters
        # process the header parameters
        if evr_language is not None:
            _header_params["EVR-LANGUAGE"] = evr_language
        # process the form parameters
        # process the body parameter
        if add_waybill_note_request is not None:
            _body_params = add_waybill_note_request

        # set the HTTP header `Accept`
        if "Accept" not in _header_params:
            _header_params["Accept"] = self.api_client.select_header_accept(
                ["application/json"]
            )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params["Content-Type"] = _content_type
        else:
            _default_content_type = self.api_client.select_header_content_type(
                ["application/json"]
            )
            if _default_content_type is not None:
                _header_params["Content-Type"] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = ["SecretApiKey"]

        return self.api_client.param_serialize(
            method="POST",
            resource_path="/api/waybills/{number}/note",
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth,
        )

    @validate_call
    def waybills_add_shipments(
        self,
        number: Annotated[
            StrictStr, Field(description="Veoselehe number (tõstutundetu)")
        ],
        add_shipments_to_waybill_request: AddShipmentsToWaybillRequest,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> None:
        """Veoselehele veose lisamine

        Lisab veoselehele uue veose. Veoseid saab lisada veoselehele vedaja ja veoselehe looja. Veoseid saab lisada ainult veos olevatele veoselehtedele.

        :param number: Veoselehe number (tõstutundetu) (required)
        :type number: str
        :param add_shipments_to_waybill_request: (required)
        :type add_shipments_to_waybill_request: AddShipmentsToWaybillRequest
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_add_shipments_serialize(
            number=number,
            add_shipments_to_waybill_request=add_shipments_to_waybill_request,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "404": "ProblemDetails",
            "200": None,
            "400": "ValidationResult",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data

    @validate_call
    def waybills_add_shipments_with_http_info(
        self,
        number: Annotated[
            StrictStr, Field(description="Veoselehe number (tõstutundetu)")
        ],
        add_shipments_to_waybill_request: AddShipmentsToWaybillRequest,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[None]:
        """Veoselehele veose lisamine

        Lisab veoselehele uue veose. Veoseid saab lisada veoselehele vedaja ja veoselehe looja. Veoseid saab lisada ainult veos olevatele veoselehtedele.

        :param number: Veoselehe number (tõstutundetu) (required)
        :type number: str
        :param add_shipments_to_waybill_request: (required)
        :type add_shipments_to_waybill_request: AddShipmentsToWaybillRequest
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_add_shipments_serialize(
            number=number,
            add_shipments_to_waybill_request=add_shipments_to_waybill_request,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "404": "ProblemDetails",
            "200": None,
            "400": "ValidationResult",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )

    @validate_call
    def waybills_add_shipments_without_preload_content(
        self,
        number: Annotated[
            StrictStr, Field(description="Veoselehe number (tõstutundetu)")
        ],
        add_shipments_to_waybill_request: AddShipmentsToWaybillRequest,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Veoselehele veose lisamine

        Lisab veoselehele uue veose. Veoseid saab lisada veoselehele vedaja ja veoselehe looja. Veoseid saab lisada ainult veos olevatele veoselehtedele.

        :param number: Veoselehe number (tõstutundetu) (required)
        :type number: str
        :param add_shipments_to_waybill_request: (required)
        :type add_shipments_to_waybill_request: AddShipmentsToWaybillRequest
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_add_shipments_serialize(
            number=number,
            add_shipments_to_waybill_request=add_shipments_to_waybill_request,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "404": "ProblemDetails",
            "200": None,
            "400": "ValidationResult",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        return response_data.response

    def _waybills_add_shipments_serialize(
        self,
        number,
        add_shipments_to_waybill_request,
        evr_language,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:
        _host = None

        _collection_formats: Dict[str, str] = {}

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if number is not None:
            _path_params["number"] = number
        # process the query parameters
        # process the header parameters
        if evr_language is not None:
            _header_params["EVR-LANGUAGE"] = evr_language
        # process the form parameters
        # process the body parameter
        if add_shipments_to_waybill_request is not None:
            _body_params = add_shipments_to_waybill_request

        # set the HTTP header `Accept`
        if "Accept" not in _header_params:
            _header_params["Accept"] = self.api_client.select_header_accept(
                ["application/json"]
            )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params["Content-Type"] = _content_type
        else:
            _default_content_type = self.api_client.select_header_content_type(
                ["application/json"]
            )
            if _default_content_type is not None:
                _header_params["Content-Type"] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = ["SecretApiKey"]

        return self.api_client.param_serialize(
            method="POST",
            resource_path="/api/waybills/{number}/shipments",
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth,
        )

    @validate_call
    def waybills_cancel(
        self,
        number: Annotated[
            StrictStr, Field(description="Veoselehe number (tõstutundetu)")
        ],
        cancel_waybill_request: CancelWaybillRequest,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> None:
        """Veoselehe tühistamine

        Veoselehe saab tühistada veoselehe looja, omanik, saaja, vedaja ja alltöövõtja kuni veoseleht pole veel vastu võetud.

        :param number: Veoselehe number (tõstutundetu) (required)
        :type number: str
        :param cancel_waybill_request: (required)
        :type cancel_waybill_request: CancelWaybillRequest
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_cancel_serialize(
            number=number,
            cancel_waybill_request=cancel_waybill_request,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "404": "ProblemDetails",
            "200": None,
            "400": "ValidationResult",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data

    @validate_call
    def waybills_cancel_with_http_info(
        self,
        number: Annotated[
            StrictStr, Field(description="Veoselehe number (tõstutundetu)")
        ],
        cancel_waybill_request: CancelWaybillRequest,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[None]:
        """Veoselehe tühistamine

        Veoselehe saab tühistada veoselehe looja, omanik, saaja, vedaja ja alltöövõtja kuni veoseleht pole veel vastu võetud.

        :param number: Veoselehe number (tõstutundetu) (required)
        :type number: str
        :param cancel_waybill_request: (required)
        :type cancel_waybill_request: CancelWaybillRequest
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_cancel_serialize(
            number=number,
            cancel_waybill_request=cancel_waybill_request,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "404": "ProblemDetails",
            "200": None,
            "400": "ValidationResult",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )

    @validate_call
    def waybills_cancel_without_preload_content(
        self,
        number: Annotated[
            StrictStr, Field(description="Veoselehe number (tõstutundetu)")
        ],
        cancel_waybill_request: CancelWaybillRequest,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Veoselehe tühistamine

        Veoselehe saab tühistada veoselehe looja, omanik, saaja, vedaja ja alltöövõtja kuni veoseleht pole veel vastu võetud.

        :param number: Veoselehe number (tõstutundetu) (required)
        :type number: str
        :param cancel_waybill_request: (required)
        :type cancel_waybill_request: CancelWaybillRequest
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_cancel_serialize(
            number=number,
            cancel_waybill_request=cancel_waybill_request,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "404": "ProblemDetails",
            "200": None,
            "400": "ValidationResult",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        return response_data.response

    def _waybills_cancel_serialize(
        self,
        number,
        cancel_waybill_request,
        evr_language,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:
        _host = None

        _collection_formats: Dict[str, str] = {}

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if number is not None:
            _path_params["number"] = number
        # process the query parameters
        # process the header parameters
        if evr_language is not None:
            _header_params["EVR-LANGUAGE"] = evr_language
        # process the form parameters
        # process the body parameter
        if cancel_waybill_request is not None:
            _body_params = cancel_waybill_request

        # set the HTTP header `Accept`
        if "Accept" not in _header_params:
            _header_params["Accept"] = self.api_client.select_header_accept(
                ["application/json"]
            )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params["Content-Type"] = _content_type
        else:
            _default_content_type = self.api_client.select_header_content_type(
                ["application/json"]
            )
            if _default_content_type is not None:
                _header_params["Content-Type"] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = ["SecretApiKey"]

        return self.api_client.param_serialize(
            method="POST",
            resource_path="/api/waybills/{number}/cancel",
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth,
        )

    @validate_call
    def waybills_finish(
        self,
        number: Annotated[
            StrictStr, Field(description="Veoselehe number (tõstutundetu)")
        ],
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> None:
        """Veoselehe lõpetamine

        Lõpetab veoselehe ja veoselehe staatuseks märgitakse \"veoseleht lõpetatud\" (status: \"finished\"). Veoselehte saavad lõpetada veoselehele märgitud saaja ning volitatud mõõtja ja seda ainult \"koorem maas\" staatuses.

        :param number: Veoselehe number (tõstutundetu) (required)
        :type number: str
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_finish_serialize(
            number=number,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "404": "ProblemDetails",
            "200": None,
            "400": "ValidationResult",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data

    @validate_call
    def waybills_finish_with_http_info(
        self,
        number: Annotated[
            StrictStr, Field(description="Veoselehe number (tõstutundetu)")
        ],
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[None]:
        """Veoselehe lõpetamine

        Lõpetab veoselehe ja veoselehe staatuseks märgitakse \"veoseleht lõpetatud\" (status: \"finished\"). Veoselehte saavad lõpetada veoselehele märgitud saaja ning volitatud mõõtja ja seda ainult \"koorem maas\" staatuses.

        :param number: Veoselehe number (tõstutundetu) (required)
        :type number: str
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_finish_serialize(
            number=number,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "404": "ProblemDetails",
            "200": None,
            "400": "ValidationResult",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )

    @validate_call
    def waybills_finish_without_preload_content(
        self,
        number: Annotated[
            StrictStr, Field(description="Veoselehe number (tõstutundetu)")
        ],
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Veoselehe lõpetamine

        Lõpetab veoselehe ja veoselehe staatuseks märgitakse \"veoseleht lõpetatud\" (status: \"finished\"). Veoselehte saavad lõpetada veoselehele märgitud saaja ning volitatud mõõtja ja seda ainult \"koorem maas\" staatuses.

        :param number: Veoselehe number (tõstutundetu) (required)
        :type number: str
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_finish_serialize(
            number=number,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "404": "ProblemDetails",
            "200": None,
            "400": "ValidationResult",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        return response_data.response

    def _waybills_finish_serialize(
        self,
        number,
        evr_language,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:
        _host = None

        _collection_formats: Dict[str, str] = {}

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if number is not None:
            _path_params["number"] = number
        # process the query parameters
        # process the header parameters
        if evr_language is not None:
            _header_params["EVR-LANGUAGE"] = evr_language
        # process the form parameters
        # process the body parameter

        # set the HTTP header `Accept`
        if "Accept" not in _header_params:
            _header_params["Accept"] = self.api_client.select_header_accept(
                ["application/json"]
            )

        # authentication setting
        _auth_settings: List[str] = ["SecretApiKey"]

        return self.api_client.param_serialize(
            method="POST",
            resource_path="/api/waybills/{number}/finish",
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth,
        )

    @validate_call
    def waybills_list(
        self,
        created_after: Annotated[
            Optional[datetime],
            Field(
                description="Filtreerib veoselehed, mis on loodud hiljem või samal ajal. Kui 'created_after' ja 'created_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse."
            ),
        ] = None,
        created_before: Annotated[
            Optional[datetime],
            Field(
                description="Filtreerib veoselehed, mis on loodud varem või samal ajal. Kui 'created_after' ja 'created_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse."
            ),
        ] = None,
        last_modified_after: Annotated[
            Optional[datetime],
            Field(
                description="Filtreerib veoselehed, mis on muutunud pärast määratud aega. Kui 'last_modified_after' ja 'last_modified_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse."
            ),
        ] = None,
        last_modified_before: Annotated[
            Optional[datetime],
            Field(
                description="Filtreerib veoselehed, mis on muutunud enne määratud aega. Kui 'last_modified_after' ja 'last_modified_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse."
            ),
        ] = None,
        status: Annotated[
            Optional[WaybillStatus],
            Field(
                description="Filtreerib veoselehed, mis vastavad määratud staatusele"
            ),
        ] = None,
        owner_code: Annotated[
            Optional[StrictStr],
            Field(description="Filtreerib veoselehed, millel on sama omaniku kood"),
        ] = None,
        transporter_code: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib veoselehed, millel on sama transportija kood"
            ),
        ] = None,
        receiver_code: Annotated[
            Optional[StrictStr],
            Field(description="Filtreerib veoselehed, millel on sama saaja kood"),
        ] = None,
        van_registration_number: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib veoselehed, millel on sama veoki registreerimisnumber (tõstutundlik)"
            ),
        ] = None,
        trailer_registration_number: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib veoselehed, millel on sama haagise registreerimisnumber (tõstutundlik)"
            ),
        ] = None,
        driver_id_code: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib veoselehed, millel on sama transportija autojuhi isikukood (tõstutundlik)"
            ),
        ] = None,
        place_of_delivery_code: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib veoselehed millel on sama tarnekoha kood (tõstutundlik)"
            ),
        ] = None,
        subcontractor_code: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib veoselehed millel on sama alltöövõtja kood (tõstutundlik)"
            ),
        ] = None,
        text: Annotated[
            Optional[StrictStr],
            Field(
                description="Vabateksti otsing. Toetatud on järgmine süntaks: * ilma jutumärkideta tekst: sõnade vahel rakendatakse loogiline JA. * jutumärkides tekst: otsitakse jutumärkides olevat lauset. * OR: loogiline VÕI operaator sõnade vahel. * -: loogiline EITUS."
            ),
        ] = None,
        sort: Annotated[
            Optional[WaybillSortField],
            Field(description="Sorteerib tulemused valitud välja järgi"),
        ] = None,
        page: Annotated[
            Optional[StrictInt], Field(description="Määrab tagastatava lehekülje")
        ] = None,
        page_size: Annotated[
            Optional[Annotated[int, Field(le=500, strict=True, ge=1)]],
            Field(description="Määrab lehekülje suuruse"),
        ] = None,
        include_latest_measurements: Annotated[
            Optional[StrictBool],
            Field(
                description="Kas lisada veoselehele viimase mõõtmise andmed (vaikimisi ei lisata)"
            ),
        ] = None,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> PagedResultOfWaybill:
        """Veoselehtede pärimine

        Tagastab filtritele vastavad veoselehed. Veoselehti saavad pärida ainult nendega seotud asutused.

        :param created_after: Filtreerib veoselehed, mis on loodud hiljem või samal ajal. Kui 'created_after' ja 'created_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse.
        :type created_after: datetime
        :param created_before: Filtreerib veoselehed, mis on loodud varem või samal ajal. Kui 'created_after' ja 'created_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse.
        :type created_before: datetime
        :param last_modified_after: Filtreerib veoselehed, mis on muutunud pärast määratud aega. Kui 'last_modified_after' ja 'last_modified_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse.
        :type last_modified_after: datetime
        :param last_modified_before: Filtreerib veoselehed, mis on muutunud enne määratud aega. Kui 'last_modified_after' ja 'last_modified_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse.
        :type last_modified_before: datetime
        :param status: Filtreerib veoselehed, mis vastavad määratud staatusele
        :type status: WaybillStatus
        :param owner_code: Filtreerib veoselehed, millel on sama omaniku kood
        :type owner_code: str
        :param transporter_code: Filtreerib veoselehed, millel on sama transportija kood
        :type transporter_code: str
        :param receiver_code: Filtreerib veoselehed, millel on sama saaja kood
        :type receiver_code: str
        :param van_registration_number: Filtreerib veoselehed, millel on sama veoki registreerimisnumber (tõstutundlik)
        :type van_registration_number: str
        :param trailer_registration_number: Filtreerib veoselehed, millel on sama haagise registreerimisnumber (tõstutundlik)
        :type trailer_registration_number: str
        :param driver_id_code: Filtreerib veoselehed, millel on sama transportija autojuhi isikukood (tõstutundlik)
        :type driver_id_code: str
        :param place_of_delivery_code: Filtreerib veoselehed millel on sama tarnekoha kood (tõstutundlik)
        :type place_of_delivery_code: str
        :param subcontractor_code: Filtreerib veoselehed millel on sama alltöövõtja kood (tõstutundlik)
        :type subcontractor_code: str
        :param text: Vabateksti otsing. Toetatud on järgmine süntaks: * ilma jutumärkideta tekst: sõnade vahel rakendatakse loogiline JA. * jutumärkides tekst: otsitakse jutumärkides olevat lauset. * OR: loogiline VÕI operaator sõnade vahel. * -: loogiline EITUS.
        :type text: str
        :param sort: Sorteerib tulemused valitud välja järgi
        :type sort: WaybillSortField
        :param page: Määrab tagastatava lehekülje
        :type page: int
        :param page_size: Määrab lehekülje suuruse
        :type page_size: int
        :param include_latest_measurements: Kas lisada veoselehele viimase mõõtmise andmed (vaikimisi ei lisata)
        :type include_latest_measurements: bool
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_get_serialize(
            created_after=created_after,
            created_before=created_before,
            last_modified_after=last_modified_after,
            last_modified_before=last_modified_before,
            status=status,
            owner_code=owner_code,
            transporter_code=transporter_code,
            receiver_code=receiver_code,
            van_registration_number=van_registration_number,
            trailer_registration_number=trailer_registration_number,
            driver_id_code=driver_id_code,
            place_of_delivery_code=place_of_delivery_code,
            subcontractor_code=subcontractor_code,
            text=text,
            sort=sort,
            page=page,
            page_size=page_size,
            include_latest_measurements=include_latest_measurements,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "200": "PagedResultOfWaybill",
            "400": "ValidationResult",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data

    @validate_call
    def waybills_list_with_http_info(
        self,
        created_after: Annotated[
            Optional[datetime],
            Field(
                description="Filtreerib veoselehed, mis on loodud hiljem või samal ajal. Kui 'created_after' ja 'created_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse."
            ),
        ] = None,
        created_before: Annotated[
            Optional[datetime],
            Field(
                description="Filtreerib veoselehed, mis on loodud varem või samal ajal. Kui 'created_after' ja 'created_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse."
            ),
        ] = None,
        last_modified_after: Annotated[
            Optional[datetime],
            Field(
                description="Filtreerib veoselehed, mis on muutunud pärast määratud aega. Kui 'last_modified_after' ja 'last_modified_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse."
            ),
        ] = None,
        last_modified_before: Annotated[
            Optional[datetime],
            Field(
                description="Filtreerib veoselehed, mis on muutunud enne määratud aega. Kui 'last_modified_after' ja 'last_modified_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse."
            ),
        ] = None,
        status: Annotated[
            Optional[WaybillStatus],
            Field(
                description="Filtreerib veoselehed, mis vastavad määratud staatusele"
            ),
        ] = None,
        owner_code: Annotated[
            Optional[StrictStr],
            Field(description="Filtreerib veoselehed, millel on sama omaniku kood"),
        ] = None,
        transporter_code: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib veoselehed, millel on sama transportija kood"
            ),
        ] = None,
        receiver_code: Annotated[
            Optional[StrictStr],
            Field(description="Filtreerib veoselehed, millel on sama saaja kood"),
        ] = None,
        van_registration_number: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib veoselehed, millel on sama veoki registreerimisnumber (tõstutundlik)"
            ),
        ] = None,
        trailer_registration_number: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib veoselehed, millel on sama haagise registreerimisnumber (tõstutundlik)"
            ),
        ] = None,
        driver_id_code: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib veoselehed, millel on sama transportija autojuhi isikukood (tõstutundlik)"
            ),
        ] = None,
        place_of_delivery_code: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib veoselehed millel on sama tarnekoha kood (tõstutundlik)"
            ),
        ] = None,
        subcontractor_code: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib veoselehed millel on sama alltöövõtja kood (tõstutundlik)"
            ),
        ] = None,
        text: Annotated[
            Optional[StrictStr],
            Field(
                description="Vabateksti otsing. Toetatud on järgmine süntaks: * ilma jutumärkideta tekst: sõnade vahel rakendatakse loogiline JA. * jutumärkides tekst: otsitakse jutumärkides olevat lauset. * OR: loogiline VÕI operaator sõnade vahel. * -: loogiline EITUS."
            ),
        ] = None,
        sort: Annotated[
            Optional[WaybillSortField],
            Field(description="Sorteerib tulemused valitud välja järgi"),
        ] = None,
        page: Annotated[
            Optional[StrictInt], Field(description="Määrab tagastatava lehekülje")
        ] = None,
        page_size: Annotated[
            Optional[Annotated[int, Field(le=500, strict=True, ge=1)]],
            Field(description="Määrab lehekülje suuruse"),
        ] = None,
        include_latest_measurements: Annotated[
            Optional[StrictBool],
            Field(
                description="Kas lisada veoselehele viimase mõõtmise andmed (vaikimisi ei lisata)"
            ),
        ] = None,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[PagedResultOfWaybill]:
        """Veoselehtede pärimine

        Tagastab filtritele vastavad veoselehed. Veoselehti saavad pärida ainult nendega seotud asutused.

        :param created_after: Filtreerib veoselehed, mis on loodud hiljem või samal ajal. Kui 'created_after' ja 'created_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse.
        :type created_after: datetime
        :param created_before: Filtreerib veoselehed, mis on loodud varem või samal ajal. Kui 'created_after' ja 'created_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse.
        :type created_before: datetime
        :param last_modified_after: Filtreerib veoselehed, mis on muutunud pärast määratud aega. Kui 'last_modified_after' ja 'last_modified_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse.
        :type last_modified_after: datetime
        :param last_modified_before: Filtreerib veoselehed, mis on muutunud enne määratud aega. Kui 'last_modified_after' ja 'last_modified_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse.
        :type last_modified_before: datetime
        :param status: Filtreerib veoselehed, mis vastavad määratud staatusele
        :type status: WaybillStatus
        :param owner_code: Filtreerib veoselehed, millel on sama omaniku kood
        :type owner_code: str
        :param transporter_code: Filtreerib veoselehed, millel on sama transportija kood
        :type transporter_code: str
        :param receiver_code: Filtreerib veoselehed, millel on sama saaja kood
        :type receiver_code: str
        :param van_registration_number: Filtreerib veoselehed, millel on sama veoki registreerimisnumber (tõstutundlik)
        :type van_registration_number: str
        :param trailer_registration_number: Filtreerib veoselehed, millel on sama haagise registreerimisnumber (tõstutundlik)
        :type trailer_registration_number: str
        :param driver_id_code: Filtreerib veoselehed, millel on sama transportija autojuhi isikukood (tõstutundlik)
        :type driver_id_code: str
        :param place_of_delivery_code: Filtreerib veoselehed millel on sama tarnekoha kood (tõstutundlik)
        :type place_of_delivery_code: str
        :param subcontractor_code: Filtreerib veoselehed millel on sama alltöövõtja kood (tõstutundlik)
        :type subcontractor_code: str
        :param text: Vabateksti otsing. Toetatud on järgmine süntaks: * ilma jutumärkideta tekst: sõnade vahel rakendatakse loogiline JA. * jutumärkides tekst: otsitakse jutumärkides olevat lauset. * OR: loogiline VÕI operaator sõnade vahel. * -: loogiline EITUS.
        :type text: str
        :param sort: Sorteerib tulemused valitud välja järgi
        :type sort: WaybillSortField
        :param page: Määrab tagastatava lehekülje
        :type page: int
        :param page_size: Määrab lehekülje suuruse
        :type page_size: int
        :param include_latest_measurements: Kas lisada veoselehele viimase mõõtmise andmed (vaikimisi ei lisata)
        :type include_latest_measurements: bool
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_get_serialize(
            created_after=created_after,
            created_before=created_before,
            last_modified_after=last_modified_after,
            last_modified_before=last_modified_before,
            status=status,
            owner_code=owner_code,
            transporter_code=transporter_code,
            receiver_code=receiver_code,
            van_registration_number=van_registration_number,
            trailer_registration_number=trailer_registration_number,
            driver_id_code=driver_id_code,
            place_of_delivery_code=place_of_delivery_code,
            subcontractor_code=subcontractor_code,
            text=text,
            sort=sort,
            page=page,
            page_size=page_size,
            include_latest_measurements=include_latest_measurements,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "200": "PagedResultOfWaybill",
            "400": "ValidationResult",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )

    @validate_call
    def waybills_get_without_preload_content(
        self,
        created_after: Annotated[
            Optional[datetime],
            Field(
                description="Filtreerib veoselehed, mis on loodud hiljem või samal ajal. Kui 'created_after' ja 'created_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse."
            ),
        ] = None,
        created_before: Annotated[
            Optional[datetime],
            Field(
                description="Filtreerib veoselehed, mis on loodud varem või samal ajal. Kui 'created_after' ja 'created_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse."
            ),
        ] = None,
        last_modified_after: Annotated[
            Optional[datetime],
            Field(
                description="Filtreerib veoselehed, mis on muutunud pärast määratud aega. Kui 'last_modified_after' ja 'last_modified_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse."
            ),
        ] = None,
        last_modified_before: Annotated[
            Optional[datetime],
            Field(
                description="Filtreerib veoselehed, mis on muutunud enne määratud aega. Kui 'last_modified_after' ja 'last_modified_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse."
            ),
        ] = None,
        status: Annotated[
            Optional[WaybillStatus],
            Field(
                description="Filtreerib veoselehed, mis vastavad määratud staatusele"
            ),
        ] = None,
        owner_code: Annotated[
            Optional[StrictStr],
            Field(description="Filtreerib veoselehed, millel on sama omaniku kood"),
        ] = None,
        transporter_code: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib veoselehed, millel on sama transportija kood"
            ),
        ] = None,
        receiver_code: Annotated[
            Optional[StrictStr],
            Field(description="Filtreerib veoselehed, millel on sama saaja kood"),
        ] = None,
        van_registration_number: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib veoselehed, millel on sama veoki registreerimisnumber (tõstutundlik)"
            ),
        ] = None,
        trailer_registration_number: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib veoselehed, millel on sama haagise registreerimisnumber (tõstutundlik)"
            ),
        ] = None,
        driver_id_code: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib veoselehed, millel on sama transportija autojuhi isikukood (tõstutundlik)"
            ),
        ] = None,
        place_of_delivery_code: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib veoselehed millel on sama tarnekoha kood (tõstutundlik)"
            ),
        ] = None,
        subcontractor_code: Annotated[
            Optional[StrictStr],
            Field(
                description="Filtreerib veoselehed millel on sama alltöövõtja kood (tõstutundlik)"
            ),
        ] = None,
        text: Annotated[
            Optional[StrictStr],
            Field(
                description="Vabateksti otsing. Toetatud on järgmine süntaks: * ilma jutumärkideta tekst: sõnade vahel rakendatakse loogiline JA. * jutumärkides tekst: otsitakse jutumärkides olevat lauset. * OR: loogiline VÕI operaator sõnade vahel. * -: loogiline EITUS."
            ),
        ] = None,
        sort: Annotated[
            Optional[WaybillSortField],
            Field(description="Sorteerib tulemused valitud välja järgi"),
        ] = None,
        page: Annotated[
            Optional[StrictInt], Field(description="Määrab tagastatava lehekülje")
        ] = None,
        page_size: Annotated[
            Optional[Annotated[int, Field(le=500, strict=True, ge=1)]],
            Field(description="Määrab lehekülje suuruse"),
        ] = None,
        include_latest_measurements: Annotated[
            Optional[StrictBool],
            Field(
                description="Kas lisada veoselehele viimase mõõtmise andmed (vaikimisi ei lisata)"
            ),
        ] = None,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Veoselehtede pärimine

        Tagastab filtritele vastavad veoselehed. Veoselehti saavad pärida ainult nendega seotud asutused.

        :param created_after: Filtreerib veoselehed, mis on loodud hiljem või samal ajal. Kui 'created_after' ja 'created_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse.
        :type created_after: datetime
        :param created_before: Filtreerib veoselehed, mis on loodud varem või samal ajal. Kui 'created_after' ja 'created_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse.
        :type created_before: datetime
        :param last_modified_after: Filtreerib veoselehed, mis on muutunud pärast määratud aega. Kui 'last_modified_after' ja 'last_modified_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse.
        :type last_modified_after: datetime
        :param last_modified_before: Filtreerib veoselehed, mis on muutunud enne määratud aega. Kui 'last_modified_after' ja 'last_modified_before' on mõlemad määratud, peab nende vahe jääma 1 kuu piiresse.
        :type last_modified_before: datetime
        :param status: Filtreerib veoselehed, mis vastavad määratud staatusele
        :type status: WaybillStatus
        :param owner_code: Filtreerib veoselehed, millel on sama omaniku kood
        :type owner_code: str
        :param transporter_code: Filtreerib veoselehed, millel on sama transportija kood
        :type transporter_code: str
        :param receiver_code: Filtreerib veoselehed, millel on sama saaja kood
        :type receiver_code: str
        :param van_registration_number: Filtreerib veoselehed, millel on sama veoki registreerimisnumber (tõstutundlik)
        :type van_registration_number: str
        :param trailer_registration_number: Filtreerib veoselehed, millel on sama haagise registreerimisnumber (tõstutundlik)
        :type trailer_registration_number: str
        :param driver_id_code: Filtreerib veoselehed, millel on sama transportija autojuhi isikukood (tõstutundlik)
        :type driver_id_code: str
        :param place_of_delivery_code: Filtreerib veoselehed millel on sama tarnekoha kood (tõstutundlik)
        :type place_of_delivery_code: str
        :param subcontractor_code: Filtreerib veoselehed millel on sama alltöövõtja kood (tõstutundlik)
        :type subcontractor_code: str
        :param text: Vabateksti otsing. Toetatud on järgmine süntaks: * ilma jutumärkideta tekst: sõnade vahel rakendatakse loogiline JA. * jutumärkides tekst: otsitakse jutumärkides olevat lauset. * OR: loogiline VÕI operaator sõnade vahel. * -: loogiline EITUS.
        :type text: str
        :param sort: Sorteerib tulemused valitud välja järgi
        :type sort: WaybillSortField
        :param page: Määrab tagastatava lehekülje
        :type page: int
        :param page_size: Määrab lehekülje suuruse
        :type page_size: int
        :param include_latest_measurements: Kas lisada veoselehele viimase mõõtmise andmed (vaikimisi ei lisata)
        :type include_latest_measurements: bool
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_get_serialize(
            created_after=created_after,
            created_before=created_before,
            last_modified_after=last_modified_after,
            last_modified_before=last_modified_before,
            status=status,
            owner_code=owner_code,
            transporter_code=transporter_code,
            receiver_code=receiver_code,
            van_registration_number=van_registration_number,
            trailer_registration_number=trailer_registration_number,
            driver_id_code=driver_id_code,
            place_of_delivery_code=place_of_delivery_code,
            subcontractor_code=subcontractor_code,
            text=text,
            sort=sort,
            page=page,
            page_size=page_size,
            include_latest_measurements=include_latest_measurements,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "200": "PagedResultOfWaybill",
            "400": "ValidationResult",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        return response_data.response

    def _waybills_get_serialize(
        self,
        created_after,
        created_before,
        last_modified_after,
        last_modified_before,
        status,
        owner_code,
        transporter_code,
        receiver_code,
        van_registration_number,
        trailer_registration_number,
        driver_id_code,
        place_of_delivery_code,
        subcontractor_code,
        text,
        sort,
        page,
        page_size,
        include_latest_measurements,
        evr_language,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:
        _host = None

        _collection_formats: Dict[str, str] = {}

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        if created_after is not None:
            if isinstance(created_after, datetime):
                _query_params.append(
                    (
                        "created_after",
                        created_after.strftime(
                            self.api_client.configuration.datetime_format
                        ),
                    )
                )
            else:
                _query_params.append(("created_after", created_after))

        if created_before is not None:
            if isinstance(created_before, datetime):
                _query_params.append(
                    (
                        "created_before",
                        created_before.strftime(
                            self.api_client.configuration.datetime_format
                        ),
                    )
                )
            else:
                _query_params.append(("created_before", created_before))

        if last_modified_after is not None:
            if isinstance(last_modified_after, datetime):
                _query_params.append(
                    (
                        "last_modified_after",
                        last_modified_after.strftime(
                            self.api_client.configuration.datetime_format
                        ),
                    )
                )
            else:
                _query_params.append(("last_modified_after", last_modified_after))

        if last_modified_before is not None:
            if isinstance(last_modified_before, datetime):
                _query_params.append(
                    (
                        "last_modified_before",
                        last_modified_before.strftime(
                            self.api_client.configuration.datetime_format
                        ),
                    )
                )
            else:
                _query_params.append(("last_modified_before", last_modified_before))

        if status is not None:
            _query_params.append(("status", status.value))

        if owner_code is not None:
            _query_params.append(("owner_code", owner_code))

        if transporter_code is not None:
            _query_params.append(("transporter_code", transporter_code))

        if receiver_code is not None:
            _query_params.append(("receiver_code", receiver_code))

        if van_registration_number is not None:
            _query_params.append(("van_registration_number", van_registration_number))

        if trailer_registration_number is not None:
            _query_params.append(
                ("trailer_registration_number", trailer_registration_number)
            )

        if driver_id_code is not None:
            _query_params.append(("driver_id_code", driver_id_code))

        if place_of_delivery_code is not None:
            _query_params.append(("place_of_delivery_code", place_of_delivery_code))

        if subcontractor_code is not None:
            _query_params.append(("subcontractor_code", subcontractor_code))

        if text is not None:
            _query_params.append(("text", text))

        if sort is not None:
            _query_params.append(("sort", sort.value))

        if page is not None:
            _query_params.append(("page", page))

        if page_size is not None:
            _query_params.append(("page_size", page_size))

        if include_latest_measurements is not None:
            _query_params.append(
                ("includeLatestMeasurements", include_latest_measurements)
            )

        # process the header parameters
        if evr_language is not None:
            _header_params["EVR-LANGUAGE"] = evr_language
        # process the form parameters
        # process the body parameter

        # set the HTTP header `Accept`
        if "Accept" not in _header_params:
            _header_params["Accept"] = self.api_client.select_header_accept(
                ["application/json"]
            )

        # authentication setting
        _auth_settings: List[str] = ["SecretApiKey"]

        return self.api_client.param_serialize(
            method="GET",
            resource_path="/api/waybills",
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth,
        )

    @validate_call
    def waybills_get(
        self,
        number: Annotated[
            StrictStr, Field(description="Päritava veoselehe number (tõstutundetu)")
        ],
        include_latest_measurements: Optional[StrictBool] = None,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> Waybill:
        """Veoselehe pärimine

        Tagastab numbrile vastava veoselehe. Veoselehte saavad pärida ainult sellega seotud asutused.

        :param number: Päritava veoselehe number (tõstutundetu) (required)
        :type number: str
        :param include_latest_measurements:
        :type include_latest_measurements: bool
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_get2_serialize(
            number=number,
            include_latest_measurements=include_latest_measurements,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "404": "ProblemDetails",
            "200": "Waybill",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data

    @validate_call
    def waybills_get_with_http_info(
        self,
        number: Annotated[
            StrictStr, Field(description="Päritava veoselehe number (tõstutundetu)")
        ],
        include_latest_measurements: Optional[StrictBool] = None,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[Waybill]:
        """Veoselehe pärimine

        Tagastab numbrile vastava veoselehe. Veoselehte saavad pärida ainult sellega seotud asutused.

        :param number: Päritava veoselehe number (tõstutundetu) (required)
        :type number: str
        :param include_latest_measurements:
        :type include_latest_measurements: bool
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_get2_serialize(
            number=number,
            include_latest_measurements=include_latest_measurements,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "404": "ProblemDetails",
            "200": "Waybill",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )

    @validate_call
    def waybills_get2_without_preload_content(
        self,
        number: Annotated[
            StrictStr, Field(description="Päritava veoselehe number (tõstutundetu)")
        ],
        include_latest_measurements: Optional[StrictBool] = None,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Veoselehe pärimine

        Tagastab numbrile vastava veoselehe. Veoselehte saavad pärida ainult sellega seotud asutused.

        :param number: Päritava veoselehe number (tõstutundetu) (required)
        :type number: str
        :param include_latest_measurements:
        :type include_latest_measurements: bool
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_get2_serialize(
            number=number,
            include_latest_measurements=include_latest_measurements,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "404": "ProblemDetails",
            "200": "Waybill",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        return response_data.response

    def _waybills_get2_serialize(
        self,
        number,
        include_latest_measurements,
        evr_language,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:
        _host = None

        _collection_formats: Dict[str, str] = {}

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if number is not None:
            _path_params["number"] = number
        # process the query parameters
        if include_latest_measurements is not None:
            _query_params.append(
                ("includeLatestMeasurements", include_latest_measurements)
            )

        # process the header parameters
        if evr_language is not None:
            _header_params["EVR-LANGUAGE"] = evr_language
        # process the form parameters
        # process the body parameter

        # set the HTTP header `Accept`
        if "Accept" not in _header_params:
            _header_params["Accept"] = self.api_client.select_header_accept(
                ["application/json"]
            )

        # authentication setting
        _auth_settings: List[str] = ["SecretApiKey"]

        return self.api_client.param_serialize(
            method="GET",
            resource_path="/api/waybills/{number}",
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth,
        )

    @validate_call
    def waybills_post(
        self,
        start_waybill_request: Annotated[
            StartWaybillRequest, Field(description="Veoselehe andmed")
        ],
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> str:
        """Veoselehe loomine

        Loob veoselehe staatusega \"vedu alustatud\" (status: \"shipping\"). Veo alustaja peab olema ise märgitud veoselehele kas omanikuks või vedajaks. Kui metsamaterjali saaja on EVR'iga liitunud asutus, peab veoselehel märgitud tarnekoht kuuluma ka saaja asutusele. Toimingu õnnestumisel tagastatakse loodud veoselehe number.

        :param start_waybill_request: Veoselehe andmed (required)
        :type start_waybill_request: StartWaybillRequest
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_post_serialize(
            start_waybill_request=start_waybill_request,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "200": "str",
            "400": "ValidationResult",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data

    @validate_call
    def waybills_post_with_http_info(
        self,
        start_waybill_request: Annotated[
            StartWaybillRequest, Field(description="Veoselehe andmed")
        ],
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[str]:
        """Veoselehe loomine

        Loob veoselehe staatusega \"vedu alustatud\" (status: \"shipping\"). Veo alustaja peab olema ise märgitud veoselehele kas omanikuks või vedajaks. Kui metsamaterjali saaja on EVR'iga liitunud asutus, peab veoselehel märgitud tarnekoht kuuluma ka saaja asutusele. Toimingu õnnestumisel tagastatakse loodud veoselehe number.

        :param start_waybill_request: Veoselehe andmed (required)
        :type start_waybill_request: StartWaybillRequest
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_post_serialize(
            start_waybill_request=start_waybill_request,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "200": "str",
            "400": "ValidationResult",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )

    @validate_call
    def waybills_post_without_preload_content(
        self,
        start_waybill_request: Annotated[
            StartWaybillRequest, Field(description="Veoselehe andmed")
        ],
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Veoselehe loomine

        Loob veoselehe staatusega \"vedu alustatud\" (status: \"shipping\"). Veo alustaja peab olema ise märgitud veoselehele kas omanikuks või vedajaks. Kui metsamaterjali saaja on EVR'iga liitunud asutus, peab veoselehel märgitud tarnekoht kuuluma ka saaja asutusele. Toimingu õnnestumisel tagastatakse loodud veoselehe number.

        :param start_waybill_request: Veoselehe andmed (required)
        :type start_waybill_request: StartWaybillRequest
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_post_serialize(
            start_waybill_request=start_waybill_request,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "200": "str",
            "400": "ValidationResult",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        return response_data.response

    def _waybills_post_serialize(
        self,
        start_waybill_request,
        evr_language,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:
        _host = None

        _collection_formats: Dict[str, str] = {}

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        # process the header parameters
        if evr_language is not None:
            _header_params["EVR-LANGUAGE"] = evr_language
        # process the form parameters
        # process the body parameter
        if start_waybill_request is not None:
            _body_params = start_waybill_request

        # set the HTTP header `Accept`
        if "Accept" not in _header_params:
            _header_params["Accept"] = self.api_client.select_header_accept(
                ["application/json"]
            )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params["Content-Type"] = _content_type
        else:
            _default_content_type = self.api_client.select_header_content_type(
                ["application/json"]
            )
            if _default_content_type is not None:
                _header_params["Content-Type"] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = ["SecretApiKey"]

        return self.api_client.param_serialize(
            method="POST",
            resource_path="/api/waybills",
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth,
        )

    @validate_call
    def waybills_unload(
        self,
        number: Annotated[
            StrictStr, Field(description="Veoselehe number (tõstutundetu)")
        ],
        unload_waybill_request: UnloadWaybillRequest,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> None:
        """Veoselehel veo lõpetamine

        Lõpetab veo veoselehel ja veoselehe staatuseks märgitakse \"koorem maas\" (status: \"unloaded\"). Vedu saab lõpetada veoselehe looja või vedaja ja seda ainult \"vedu alustatud\" (status: shipping) staatuses.

        :param number: Veoselehe number (tõstutundetu) (required)
        :type number: str
        :param unload_waybill_request: (required)
        :type unload_waybill_request: UnloadWaybillRequest
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_unload_serialize(
            number=number,
            unload_waybill_request=unload_waybill_request,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "404": "ProblemDetails",
            "200": None,
            "400": "ValidationResult",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data

    @validate_call
    def waybills_unload_with_http_info(
        self,
        number: Annotated[
            StrictStr, Field(description="Veoselehe number (tõstutundetu)")
        ],
        unload_waybill_request: UnloadWaybillRequest,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[None]:
        """Veoselehel veo lõpetamine

        Lõpetab veo veoselehel ja veoselehe staatuseks märgitakse \"koorem maas\" (status: \"unloaded\"). Vedu saab lõpetada veoselehe looja või vedaja ja seda ainult \"vedu alustatud\" (status: shipping) staatuses.

        :param number: Veoselehe number (tõstutundetu) (required)
        :type number: str
        :param unload_waybill_request: (required)
        :type unload_waybill_request: UnloadWaybillRequest
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_unload_serialize(
            number=number,
            unload_waybill_request=unload_waybill_request,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "404": "ProblemDetails",
            "200": None,
            "400": "ValidationResult",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )

    @validate_call
    def waybills_unload_without_preload_content(
        self,
        number: Annotated[
            StrictStr, Field(description="Veoselehe number (tõstutundetu)")
        ],
        unload_waybill_request: UnloadWaybillRequest,
        evr_language: Annotated[
            Optional[StrictStr],
            Field(
                description='Defineerib keele tagastatavatele veateadetele (toetatud on väärtused "et" eesti keele ning "en" inglise keele jaoks).'
            ),
        ] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]
            ],
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Veoselehel veo lõpetamine

        Lõpetab veo veoselehel ja veoselehe staatuseks märgitakse \"koorem maas\" (status: \"unloaded\"). Vedu saab lõpetada veoselehe looja või vedaja ja seda ainult \"vedu alustatud\" (status: shipping) staatuses.

        :param number: Veoselehe number (tõstutundetu) (required)
        :type number: str
        :param unload_waybill_request: (required)
        :type unload_waybill_request: UnloadWaybillRequest
        :param evr_language: Defineerib keele tagastatavatele veateadetele (toetatud on väärtused \"et\" eesti keele ning \"en\" inglise keele jaoks).
        :type evr_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """  # noqa: E501

        _param = self._waybills_unload_serialize(
            number=number,
            unload_waybill_request=unload_waybill_request,
            evr_language=evr_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            "401": "ProblemDetails",
            "403": "ProblemDetails",
            "404": "ProblemDetails",
            "200": None,
            "400": "ValidationResult",
        }
        response_data = self.api_client.call_api(
            *_param, _request_timeout=_request_timeout
        )
        return response_data.response

    def _waybills_unload_serialize(
        self,
        number,
        unload_waybill_request,
        evr_language,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:
        _host = None

        _collection_formats: Dict[str, str] = {}

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if number is not None:
            _path_params["number"] = number
        # process the query parameters
        # process the header parameters
        if evr_language is not None:
            _header_params["EVR-LANGUAGE"] = evr_language
        # process the form parameters
        # process the body parameter
        if unload_waybill_request is not None:
            _body_params = unload_waybill_request

        # set the HTTP header `Accept`
        if "Accept" not in _header_params:
            _header_params["Accept"] = self.api_client.select_header_accept(
                ["application/json"]
            )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params["Content-Type"] = _content_type
        else:
            _default_content_type = self.api_client.select_header_content_type(
                ["application/json"]
            )
            if _default_content_type is not None:
                _header_params["Content-Type"] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = ["SecretApiKey"]

        return self.api_client.param_serialize(
            method="POST",
            resource_path="/api/waybills/{number}/unload",
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth,
        )
