# coding: utf-8

"""
EVR API

OpenAPI Generator'i jaoks kohandatud EVR API kirjeldus. Kasuta seda juhul, kui spetsifikatsioonile vastava EVR API kirjeldusega ei õnnestu klienti genereerida.

The version of the OpenAPI document: 1.30.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing_extensions import Self

from pyevr.openapi_client.models.address import Address
from pyevr.openapi_client.models.contact_person import ContactPerson


class Organization(BaseModel):
    """
    Organization
    """  # noqa: E501

    name: Optional[StrictStr] = Field(default=None, description="Asutuse nimi")
    waybill_number_prefix: Optional[StrictStr] = Field(
        default=None, alias="waybillNumberPrefix"
    )
    register_code: Optional[StrictStr] = Field(
        default=None, description="Registrikood", alias="registerCode"
    )
    address: Optional[Address] = None
    email: Optional[StrictStr] = Field(default=None, description="Asutuse üldemail")
    phone: Optional[StrictStr] = Field(default=None, description="Asutuse üldtelefon")
    contact_persons: Optional[List[ContactPerson]] = Field(
        default=None, description="Kontaktisikud", alias="contactPersons"
    )
    __properties: ClassVar[List[str]] = [
        "name",
        "waybillNumberPrefix",
        "registerCode",
        "address",
        "email",
        "phone",
        "contactPersons",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Organization from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of address
        if self.address:
            _dict["address"] = self.address.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in contact_persons (list)
        _items = []
        if self.contact_persons:
            for _item_contact_persons in self.contact_persons:
                if _item_contact_persons:
                    _items.append(_item_contact_persons.to_dict())
            _dict["contactPersons"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Organization from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "name": obj.get("name"),
                "waybillNumberPrefix": obj.get("waybillNumberPrefix"),
                "registerCode": obj.get("registerCode"),
                "address": Address.from_dict(obj["address"])
                if obj.get("address") is not None
                else None,
                "email": obj.get("email"),
                "phone": obj.get("phone"),
                "contactPersons": [
                    ContactPerson.from_dict(_item) for _item in obj["contactPersons"]
                ]
                if obj.get("contactPersons") is not None
                else None,
            }
        )
        return _obj
