# coding: utf-8

"""
EVR API

OpenAPI Generator'i jaoks kohandatud EVR API kirjeldus. Kasuta seda juhul, kui spetsifikatsioonile vastava EVR API kirjeldusega ei õnnestu klienti genereerida.

The version of the OpenAPI document: 1.30.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field
from typing_extensions import Annotated, Self

from pyevr.openapi_client.models.address import Address
from pyevr.openapi_client.models.contact_person import ContactPerson
from pyevr.openapi_client.models.coordinates import Coordinates


class Source(BaseModel):
    """
    Source
    """  # noqa: E501

    name: Annotated[str, Field(min_length=0, strict=True, max_length=200)] = Field(
        description="Maaüksuse või laoplatsi nimi"
    )
    code: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(
        default=None, description="Laokood"
    )
    compartment: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(
        default=None, description="Kvartal"
    )
    appropriation: Optional[Annotated[str, Field(strict=True, max_length=200)]] = Field(
        default=None, description="Eraldis"
    )
    planning_area: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(
        default=None, description="Planeerimispiirkond", alias="planningArea"
    )
    address: Address
    coordinates: Optional[Coordinates] = None
    contact_person: Optional[ContactPerson] = Field(default=None, alias="contactPerson")
    near_address: Optional[Annotated[str, Field(strict=True, max_length=150)]] = Field(
        default=None, description="Lähiaadress", alias="nearAddress"
    )
    source_document_url: Optional[
        Annotated[str, Field(strict=True, max_length=2000)]
    ] = Field(
        default=None, description="Päritoludokumendi URL", alias="sourceDocumentUrl"
    )
    __properties: ClassVar[List[str]] = [
        "name",
        "code",
        "compartment",
        "appropriation",
        "planningArea",
        "address",
        "coordinates",
        "contactPerson",
        "nearAddress",
        "sourceDocumentUrl",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Source from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of address
        if self.address:
            _dict["address"] = self.address.to_dict()
        # override the default output from pydantic by calling `to_dict()` of coordinates
        if self.coordinates:
            _dict["coordinates"] = self.coordinates.to_dict()
        # override the default output from pydantic by calling `to_dict()` of contact_person
        if self.contact_person:
            _dict["contactPerson"] = self.contact_person.to_dict()
        # set to None if code (nullable) is None
        # and model_fields_set contains the field
        if self.code is None and "code" in self.model_fields_set:
            _dict["code"] = None

        # set to None if compartment (nullable) is None
        # and model_fields_set contains the field
        if self.compartment is None and "compartment" in self.model_fields_set:
            _dict["compartment"] = None

        # set to None if appropriation (nullable) is None
        # and model_fields_set contains the field
        if self.appropriation is None and "appropriation" in self.model_fields_set:
            _dict["appropriation"] = None

        # set to None if planning_area (nullable) is None
        # and model_fields_set contains the field
        if self.planning_area is None and "planning_area" in self.model_fields_set:
            _dict["planningArea"] = None

        # set to None if near_address (nullable) is None
        # and model_fields_set contains the field
        if self.near_address is None and "near_address" in self.model_fields_set:
            _dict["nearAddress"] = None

        # set to None if source_document_url (nullable) is None
        # and model_fields_set contains the field
        if (
            self.source_document_url is None
            and "source_document_url" in self.model_fields_set
        ):
            _dict["sourceDocumentUrl"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Source from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "name": obj.get("name"),
                "code": obj.get("code"),
                "compartment": obj.get("compartment"),
                "appropriation": obj.get("appropriation"),
                "planningArea": obj.get("planningArea"),
                "address": Address.from_dict(obj["address"])
                if obj.get("address") is not None
                else None,
                "coordinates": Coordinates.from_dict(obj["coordinates"])
                if obj.get("coordinates") is not None
                else None,
                "contactPerson": ContactPerson.from_dict(obj["contactPerson"])
                if obj.get("contactPerson") is not None
                else None,
                "nearAddress": obj.get("nearAddress"),
                "sourceDocumentUrl": obj.get("sourceDocumentUrl"),
            }
        )
        return _obj
